exports.command = 'bosgen'
exports.desc = 'bos stub generation for graphql schema'

exports.handler = function (context, argv) {

    console.log('bosgen Outputting...')

    let fs = require("fs");
    let schemadef = '';
    let baseFile='src/mock',
        readSchemaFile = `${baseFile}/schema/schema.graphql`,
        writeDefsFile = `${baseFile}/typeDefs.js`;
        writeEnumFile = `${baseFile}/enum.js`;

// 创建可读流
    let readerStream = fs.createReadStream(readSchemaFile);
// 设置编码为 utf8。
    readerStream.setEncoding('UTF8');
// 处理流事件 --> data, end, and error
    readerStream.on('data', function (chunk) {
        schemadef += chunk;
    });

    readerStream.on('end', function () {
        // console.log(schemadef);
        let createEnum = require('./createEnum');
        let obj = createEnum(fs, schemadef, writeEnumFile);


        let data = 'let  typeDefs=`' + schemadef + "`;export default  typeDefs;";
// 使用 utf8 编码写入数据
        writerStream.write(data, 'UTF8');
// 标记文件末尾
        writerStream.end();
    });
    readerStream.on('error', function (err) {
        console.log(err.stack);
    });
    console.log("程序执行完毕");
// 创建一个可以写入的流，写入到文件 output.txt 中
    let writerStream = fs.createWriteStream('src/mock/typeDefs.js');

// 处理流事件 --> data, end, and error
    writerStream.on('finish', function () {
        console.log("写入完成。");
    });

    writerStream.on('error', function (err) {
        console.log(err.stack);
    });

    console.log("程序执行完毕");

}
