/**
 * Created by Administrator on 2018/8/8.
 */
function filterNull(arr) {
    return arr.filter(function (item) {
        if (item || item === false) {
            return item;
        }
    })
}
function isStr(flag) {
    return typeof flag === 'string' ? {} : flag;
}
function each(flag, callback) {
    Object.keys(flag).map(function (key) {
        callback(key);
    })
}
function assembly(splitArr,key,i){
    let keyStr = splitArr[i + 1];
    if (keyStr != null) {
        obj[key] = isStr(obj[key]);  //将字符串变为{}
        obj[key][keyStr] = {
            value:keyStr,
            label:splitArr[i]
        };
    }
}
function fileAfterFunc(){
    return `let ${name}=${ JSON.stringify(obj, null, '\t')}\n
  function createProxy(obj){
    let proxy=new Proxy(obj,{
      get:function(target,property){
        if (property in target) {
          return typeof target[property]==='object'?createProxy(target[property]):target[property];
        } else {
          throw new ReferenceError("Property " + property + " does not exist.");
        }
      }
    });
    return proxy;
  }
   \n export default createProxy(${name})`;
}
let obj = {};
let name='enumData';
let defaultFile='src/mock/enum.js';


function createEnum(fs,schema,file){
    schema.replace(/enum\s*([\S]+)\s*\{([^\}]+)\}/g, function (a, t1, t2) {
        obj[t1] = t2.replace(/\s/g, '');
    });
    each(obj, function (key) {
        let splitArr = filterNull(obj[key].split('"""'));
        for (let i = 0; i < splitArr.length; i = i + 2) {
            assembly(splitArr,key,i);
        }
    });
    fs.writeFile(file||defaultFile,fileAfterFunc());
    console.log('enum success');
    return obj;
}


module.exports=createEnum;
